#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <conio.h>
#include <math.h>
#include "transforms_lib.h"

void main(argc,argv)
  int argc;
  char *argv[];
{
  FILE          *output;
  double  Greenwich_lat,
	      Greenwich_lon,
		  Greenwich_alt,
		  Greenwich_E,
		  Greenwich_F,
		  Greenwich_G,
		  airplane_az,
		  airplane_el,
		  airplane_rg,
		  airplane_x,
		  airplane_y,
		  airplane_z,
		  airplane_e,
		  airplane_f,
		  airplane_g,
		  airplane_lat,
		  airplane_lon,
		  airplane_alt,
		  lat_sec,
		  lon_sec;
  int     int_az,
	      lat_deg,
		  lat_min,
		  lon_deg,
		  lon_min;
  char    lat_char,
	      lon_char;
  
  /* output = fopen("TRN_TEST.TXT","w"); */
  output = stderr;

  fprintf(output, "All these coordinate transformations are being done in the WGS 84 ellipsoid.\n");
  fprintf(output, "We will now convert Greenwich, England known latitude - longitude - altitude to EFG...\n");
  
  Greenwich_lat = 51.477222222;		/* 51:28:38 = 51 + (28/60) + (38/3600) */
  Greenwich_lon = 0.0;				/* by definition; Greenwich is 0 lon */
  Greenwich_alt = 10.0;				/* 10 meters above sea level ? */

  LLA84toEFG84(output,Greenwich_lat,Greenwich_lon,Greenwich_alt,
	  &Greenwich_E,&Greenwich_F,&Greenwich_G);

  return_dms(LAT,Greenwich_lat,&lat_deg,&lat_min,&lat_sec,&lat_char); 
  return_dms(LON,Greenwich_lon,&lon_deg,&lon_min,&lon_sec,&lon_char); 

  /*
  fprintf(output,"123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890\n");
  fprintf(output,"              |              |              |              |              |              |\n");
  */

  fprintf(output,"Greenwich, England: \n");
  
  fprintf(output,"     latitude |   longitude  |    altitude  |       E      |      F       |     G        |\n");
  fprintf(output,"%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f\n",	  
		Greenwich_lat,Greenwich_lon,Greenwich_alt,Greenwich_E,Greenwich_F,Greenwich_G);
  fprintf(output,"  %2d:%02d:%06.3f%c %3d:%02d:%06.3f%c%15.4f\n",
		lat_deg,lat_min,lat_sec,lat_char,lon_deg,lon_min,lon_sec,lon_char,Greenwich_alt);

  fprintf(output,"\n------------------------------------------------------------------------------------------\n");

  
  fprintf(output, "Now using Greenwich as a base site, we will convert an airplane flying overhead\n");
  fprintf(output, "(in a circle) at known azimuths, elevation, range to XYZ, LLA, EFG ...\n");

  airplane_el = 15.0;    /* 15 degrees off of the horizon */
  airplane_rg = 15000.0; /* 15 km out */
  for (int_az=0;int_az<=360;int_az+=45) {  /* going around in a circle; convert every 45 degrees */ 
	  airplane_az=(double)int_az;

	  AERtoXYZ(output,airplane_az,airplane_el,airplane_rg,
			&airplane_x,&airplane_y,&airplane_z);

	  AERtoLLA84(output,airplane_az,airplane_el,airplane_rg,
			Greenwich_lat,Greenwich_lon,Greenwich_alt,
			&airplane_lat,&airplane_lon,&airplane_alt);

	  return_dms(LAT,airplane_lat,&lat_deg,&lat_min,&lat_sec,&lat_char); 
	  return_dms(LON,airplane_lon,&lon_deg,&lon_min,&lon_sec,&lon_char);

	  LLA84toEFG84(output,airplane_lat,airplane_lon,airplane_alt,
			&airplane_e,&airplane_f,&airplane_g);

	  fprintf(output,"\n------------------------------------------------------------------------------------------\n");

	  fprintf(output,"     azimuth  |    elevation |     range    |       X      |      Y       |     Z        |\n");
	  fprintf(output,"%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f\n",
			airplane_az,airplane_el,airplane_rg,airplane_x,airplane_y,airplane_z);

	  fprintf(output,"     latitude |   longitude  |    altitude  |       E      |      F       |     G        |\n");
	  fprintf(output,"%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f\n",
			airplane_lat,airplane_lon,airplane_alt,airplane_e,airplane_f,airplane_g);

	  fprintf(output,"  %2d:%02d:%06.3f%c %3d:%02d:%06.3f%c%15.4f\n",
		lat_deg,lat_min,lat_sec,lat_char,lon_deg,lon_min,lon_sec,lon_char,airplane_alt);

	  fprintf(output,"Now convert these computed E,F,G coordinates to lat,lon,alt and az,el,range for a check ...\n");

	  EFG84toLLA84(output,airplane_e,airplane_f,airplane_g,
		  &airplane_lat,&airplane_lon,&airplane_alt);

	  return_dms(LAT,airplane_lat,&lat_deg,&lat_min,&lat_sec,&lat_char); 
	  return_dms(LON,airplane_lon,&lon_deg,&lon_min,&lon_sec,&lon_char); 

	  EFG84toAER(output,airplane_e,airplane_f,airplane_g,
		  Greenwich_lat,Greenwich_lon,Greenwich_alt,
		  &airplane_az,&airplane_el,&airplane_rg);

	  fprintf(output,"     latitude |    longitude |    altitude  |   azimuth    |   elevation  |    range     |\n");
	  fprintf(output,"%15.4f%15.4f%15.4f%15.4f%15.4f%15.4f\n",
			airplane_lat,airplane_lon,airplane_alt,airplane_az,airplane_el,airplane_rg);

	  fprintf(output,"  %2d:%02d:%06.3f%c %3d:%02d:%06.3f%c%15.4f\n",
		lat_deg,lat_min,lat_sec,lat_char,lon_deg,lon_min,lon_sec,lon_char,airplane_alt);

  };
  
  fclose(output);

  printf("Program done.\n");
}
